/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The instance view of a virtual machine boot diagnostics.
 *
 */
class BootDiagnosticsInstanceView {
  /**
   * Create a BootDiagnosticsInstanceView.
   * @member {string} [consoleScreenshotBlobUri] The console screenshot blob
   * URI.
   * @member {string} [serialConsoleLogBlobUri] The Linux serial console log
   * blob Uri.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BootDiagnosticsInstanceView
   *
   * @returns {object} metadata of BootDiagnosticsInstanceView
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BootDiagnosticsInstanceView',
      type: {
        name: 'Composite',
        className: 'BootDiagnosticsInstanceView',
        modelProperties: {
          consoleScreenshotBlobUri: {
            required: false,
            serializedName: 'consoleScreenshotBlobUri',
            type: {
              name: 'String'
            }
          },
          serialConsoleLogBlobUri: {
            required: false,
            serializedName: 'serialConsoleLogBlobUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BootDiagnosticsInstanceView;
