/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Run command operation response.
 *
 * @extends models['OperationStatusResponse']
 */
class RunCommandResult extends models['OperationStatusResponse'] {
  /**
   * Create a RunCommandResult.
   * @member {object} [output] Operation output data (raw JSON)
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RunCommandResult
   *
   * @returns {object} metadata of RunCommandResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RunCommandResult',
      type: {
        name: 'Composite',
        className: 'RunCommandResult',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            readOnly: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            readOnly: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          error: {
            required: false,
            readOnly: true,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ApiError'
            }
          },
          output: {
            required: false,
            serializedName: 'properties.output',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = RunCommandResult;
