/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the parameters of a ScaleSet managed disk.
 *
 */
class VirtualMachineScaleSetManagedDiskParameters {
  /**
   * Create a VirtualMachineScaleSetManagedDiskParameters.
   * @member {string} [storageAccountType] Specifies the storage account type
   * for the managed disk. Possible values are: Standard_LRS or Premium_LRS.
   * Possible values include: 'Standard_LRS', 'Premium_LRS'
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetManagedDiskParameters
   *
   * @returns {object} metadata of VirtualMachineScaleSetManagedDiskParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetManagedDiskParameters',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetManagedDiskParameters',
        modelProperties: {
          storageAccountType: {
            required: false,
            serializedName: 'storageAccountType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Standard_LRS', 'Premium_LRS' ]
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetManagedDiskParameters;
