/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes virtual machine scale set operating system disk Update Object.
 * This should be used for Updating VMSS OS Disk.
 *
 */
class VirtualMachineScaleSetUpdateOSDisk {
  /**
   * Create a VirtualMachineScaleSetUpdateOSDisk.
   * @member {string} [caching] The caching type. Possible values include:
   * 'None', 'ReadOnly', 'ReadWrite'
   * @member {object} [image] The Source User Image VirtualHardDisk. This
   * VirtualHardDisk will be copied before using it to attach to the Virtual
   * Machine. If SourceImage is provided, the destination VirtualHardDisk
   * should not exist.
   * @member {string} [image.uri] Specifies the virtual hard disk's uri.
   * @member {array} [vhdContainers] The list of virtual hard disk container
   * uris.
   * @member {object} [managedDisk] The managed disk parameters.
   * @member {string} [managedDisk.storageAccountType] Specifies the storage
   * account type for the managed disk. Possible values are: Standard_LRS or
   * Premium_LRS. Possible values include: 'Standard_LRS', 'Premium_LRS'
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetUpdateOSDisk
   *
   * @returns {object} metadata of VirtualMachineScaleSetUpdateOSDisk
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetUpdateOSDisk',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetUpdateOSDisk',
        modelProperties: {
          caching: {
            required: false,
            serializedName: 'caching',
            type: {
              name: 'Enum',
              allowedValues: [ 'None', 'ReadOnly', 'ReadWrite' ]
            }
          },
          image: {
            required: false,
            serializedName: 'image',
            type: {
              name: 'Composite',
              className: 'VirtualHardDisk'
            }
          },
          vhdContainers: {
            required: false,
            serializedName: 'vhdContainers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          managedDisk: {
            required: false,
            serializedName: 'managedDisk',
            type: {
              name: 'Composite',
              className: 'VirtualMachineScaleSetManagedDiskParameters'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetUpdateOSDisk;
